package {
	
	import maggie.Process;
	
	public class Enemigo extends Process {
		
		private var velocidad:uint    = 6;
		private var demo:Demo         = null;
		private var nave:Nave         = null;
		private var helice:Boolean    = true;
		private var disparado:Boolean = false;
		private var sonido:Boolean    = false;
		
		public function Enemigo(x:int, y:int, image:Class, nave:Nave, demo:Demo) {
			super(25, x, y, image);
			
			this.demo = demo;
			this.nave = nave;
		}
		
		public override function run():void {
			moveLeft(velocidad);
			
			if (helice)	
				setImage(Imagenes.ENEMIGO1);
			else
				setImage(Imagenes.ENEMIGO2);
				
			helice = !helice;
			
			if (collisionWith(nave)) {
				nave.eliminar();
				eliminar();
				return;
			}
			
			if (getX() < (-getWidth())) {
				eliminar(false);
				return;
			}
			
			if ((getX() < getScreenWidth()) && (!this.sonido)) {
				demo.ejecutarSonido();
				this.sonido = true;
			}
			
			if ((!disparado) && (getX() < 800)) {
				disparado = true;
				alarm(desbloquearDisparado, 5000);
				
				var rayo:Rayo = new Rayo(getX(), getY(), Imagenes.DISPARO, demo, nave);
			}
		}
		
		private function desbloquearDisparado():void {
			disparado = false;
		}
		
		public function eliminar(explotar:Boolean = true):void {
			if (explotar) {
				playAudio(Sonidos.EXPLOSION);
				var explosion:Explosion = new Explosion(getX(), getY(), Imagenes.EXPLOSION_01);
			}
			
			finish();
			demo.detenerSonido();
			demo.crearEnemigo();
		}
	}
}