package {

	import flash.ui.Keyboard;
	import maggie.Process;

	public class Nave extends Process {
		
		private var velocidad:uint           = 6;
		private var demo:Demo                = null;
		private var disparoBloqueado:Boolean = false;
		
		public function Nave(x:uint, y:uint, image:Class, demo:Demo) {
			super(25, x, y, image);
			
			this.demo = demo;
		}
		
		public override function run():void {
			if ((!keyUp()) && (!keyDown()))
				setImage(Imagenes.NAVE_NORMAL); 
			
			if ((keyUp()) && (getY() > 5)) {
				moveUp(velocidad);
				setImage(Imagenes.NAVE_ARRIBA);
			}
			
			if ((keyDown()) && (getY() < (getScreenHeight() - getHeight() - 5))) {
				moveDown(velocidad);
				setImage(Imagenes.NAVE_ABAJO);	
			}
			
			if ((keyLeft()) && (getX() > 5))
				moveLeft(velocidad);
			
			if ((keyRight()) && (getX() < (getScreenWidth() - getWidth() - 10)))
				moveRight(velocidad);
			
			if (keySpace() && !disparoBloqueado)
				disparar(getX() + getWidth() - 5, getY() + (getHeight()/2) + 10);
		}
		
		private function desbloquearDisparo():void {
			this.disparoBloqueado = false;
		}
		
		private function disparar(x:int, y:int):void {
			var disparo:Disparo = new Disparo(x, y, Imagenes.DISPARO, demo);
			
			this.disparoBloqueado = true;
			alarm(desbloquearDisparo, 500);
			
			playAudio(Sonidos.DISPARO);
		}
		
		public function reiniciar():void {
			restartMusic();
			letMeAlone();
			demo.detenerSonido();
			
			if (demo.getVidas() > 0) {	
				demo.crearEnemigo(10);
				setImage(Imagenes.NAVE_NORMAL);
				setX(10);
				setY((getScreenHeight() / 2));
				wakeUp();
			} else
				demo.terminarJuego();
		}
		
		public function eliminar():void {
			demo.quitarVida();
			freeze();
			playAudio(Sonidos.EXPLOSION);
			var explosion:Explosion = new Explosion(getX(), getY(), Imagenes.EXPLOSION_01);
			setImage();
			var paracaidas:Paracaidas = new Paracaidas(getX(), getY(), Imagenes.PARACAIDAS, this);
		}
	}
}